# IrrationalConstants.jl

[![Build Status](https://github.com/JuliaMath/IrrationalConstants.jl/actions/workflows/CI.yml/badge.svg?branch=main)](https://github.com/JuliaMath/IrrationalConstants.jl/actions/workflows/CI.yml?query=branch%3Amain)
[![Coverage](https://codecov.io/gh/JuliaMath/IrrationalConstants.jl/branch/main/graph/badge.svg)](https://codecov.io/gh/JuliaMath/IrrationalConstants.jl)
[![Coverage](https://coveralls.io/repos/github/JuliaMath/IrrationalConstants.jl/badge.svg?branch=main)](https://coveralls.io/github/JuliaMath/IrrationalConstants.jl?branch=main)

This package defines the following `AbstractIrrational` constants:

```julia
twoπ       # 2π
fourπ      # 4π
halfπ      # π / 2
quartπ     # π / 4
invπ       # 1 / π
twoinvπ    # 2 / π
fourinvπ   # 4 / π
inv2π      # 1 / (2π)
inv4π      # 1 / (4π)
sqrt2      # √2
sqrt3      # √3
sqrtπ      # √π
sqrt2π     # √2π
sqrt4π     # √4π
sqrthalfπ  # √(π / 2)
invsqrt2   # 1 / √2
invsqrtπ   # 1 / √π
invsqrt2π  # 1 / √2π
loghalf    # log(1 / 2)
logtwo     # log(2)
logten     # log(10)
logπ       # log(π)
log2π      # log(2π)
log4π      # log(4π)
```

Pedantic note: even though these constants are instances of `AbstractIrrational`, the irrationality of some of them is not known. This is the case, for example, with `logπ`.

# We define a custom subtype of `AbstractIrrational` and
# define methods for it that are not generalized yet to `AbstractIrrational`
# in https://github.com/JuliaLang/julia/blob/e536c77f4dc693aafc48af910b4fd86b487e900d/base/irrationals.jl

abstract type IrrationalConstant <: AbstractIrrational end

# TODO: Remove definitions if they become available for `AbstractIrrational` in Base
# Ref https://github.com/JuliaLang/julia/pull/48768
function Base.show(io::IO, ::MIME"text/plain", x::IrrationalConstant)
    if get(io, :compact, false)::Bool
        print(io, x)
    else
        print(io, x, " = ", string(float(x))[1:min(end,15)], "...")
    end
end

Base.:(==)(::T, ::T) where {T<:IrrationalConstant} = true
Base.:<(::T, ::T) where {T<:IrrationalConstant} = false
Base.:<=(::T, ::T) where {T<:IrrationalConstant} = true
Base.hash(x::IrrationalConstant, h::UInt) = 3*objectid(x) - h
Base.round(x::IrrationalConstant, r::RoundingMode) = round(float(x), r)

# https://github.com/JuliaLang/julia/pull/50894
Base.typemin(::Type{T}) where {T<:IrrationalConstant} = T()
Base.typemax(::Type{T}) where {T<:IrrationalConstant} = T()

"""
    @irrational sym [val] def [T]

Define an instance named `sym` of a new singleton type `T` representing an irrational constant as subtype of
`IrrationalConstants.IrrationalConstant <: AbstractIrrational`,
with arbitrary-precision definition in terms of `BigFloat`s given by the expression `def`.

Optionally provide a pre-computed `Float64` value `val` which must equal `Float64(def)`.
It will be computed automatically if omitted.

As default, `T` is set to `sym` with the first character converted to uppercase.

An `AssertionError` is thrown when either `big(def) isa BigFloat` or `Float64(val) == Float64(def)`
returns `false`.

# Examples

```jldoctest; setup = :(import IrrationalConstants)
julia> IrrationalConstants.@irrational twoπ 2*big(π)

julia> twoπ
twoπ = 6.2831853071795...

julia> typeof(twoπ)
Twoπ

julia> IrrationalConstants.@irrational sqrt2 1.4142135623730950488 √big(2)

julia> sqrt2
sqrt2 = 1.4142135623730...

julia> IrrationalConstants.@irrational halfτ 3.14159265358979323846 pi

julia> halfτ
halfτ = 3.1415926535897...

julia> IrrationalConstants.@irrational sqrt3 1.7320508075688772 big(3)
ERROR: AssertionError: big($(Expr(:escape, :sqrt3))) isa BigFloat

julia> IrrationalConstants.@irrational sqrt5 2.2360679775 √big(5)
ERROR: AssertionError: Float64($(Expr(:escape, :sqrt5))) == Float64(big($(Expr(:escape, :sqrt5))))
```
"""
macro irrational(sym::Symbol, val::Float64, def::Union{Symbol,Expr}, T::Symbol=Symbol(uppercasefirst(string(sym))))
    irrational(__module__, sym, val, def, T)
end
macro irrational(sym::Symbol, def::Union{Symbol,Expr}, T::Symbol=Symbol(uppercasefirst(string(sym))))
    irrational(__module__, sym, :(big($(esc(sym)))), def, T)
end
function irrational(mod::Module, sym::Symbol, val::Union{Float64,Expr}, def::Union{Symbol,Expr}, T::Symbol)
    if isdefined(mod, T)
        throw(ArgumentError(LazyString("Type `", T, "` of irrational constant `", sym, "` is already defined in module `", mod, "`.")))
    end
    if sym == T
        throw(ArgumentError(LazyString("The name of the irrational constant (", sym, ") and its type (", T, ") cannot be the same. Please choose a different name for the constant or specify a different type name as the last argument to the macro.")))
    end
    esym = esc(sym)
    qsym = esc(Expr(:quote, sym))
    eT = esc(T)
    bigconvert = if isa(def, Symbol)
        # support older Julia versions prior to https://github.com/JuliaLang/julia/pull/51362
        r = VERSION < v"1.12.0-DEV.78" ? :(Base.MPFR.ROUNDING_MODE[]) : :(Base.Rounding.rounding_raw(BigFloat))
        quote
            function Base.BigFloat(::$eT, r::Base.MPFR.MPFRRoundingMode=$r; precision=precision(BigFloat))
                c = BigFloat(; precision=precision)
                ccall(($(string("mpfr_const_", def)), :libmpfr),
                      Cint, (Ref{BigFloat}, Base.MPFR.MPFRRoundingMode), c, r)
                return c
            end
        end
    else
        quote
            function Base.BigFloat(::$eT; precision=precision(BigFloat))
                setprecision(BigFloat, precision) do
                    $(esc(def))
                end
            end
        end
    end
    quote
        struct $T <: IrrationalConstant end
        const $esym = $eT()
        $bigconvert
        let v = $val, v64 = Float64(v), v32 = Float32(v)
            Base.Float64(::$eT) = v64
            Base.Float32(::$eT) = v32
        end
        Base.show(io::IO, ::$eT) = print(io, $qsym)
        @assert isa(big($esym), BigFloat)
        @assert Float64($esym) == Float64(big($esym))
        @assert Float32($esym) == Float32(big($esym))

        # https://github.com/JuliaLang/julia/pull/55886 removed these effects for generic `AbstractIrrational` subtypes
        @static if isdefined(Base, :_throw_argument_error_irrational_to_rational_bigint)
            function Base.Rational{$BigInt}(::$eT)
                Base._throw_argument_error_irrational_to_rational_bigint()
            end
        end
        @static if isdefined(Base, :_irrational_to_rational)
            Base.@assume_effects :foldable function Base.Rational{T}(x::$eT) where {T<:Integer}
                Base._irrational_to_rational(T, x)
            end
        end
        @static if isdefined(Base, :_irrational_to_float)
            Base.@assume_effects :foldable function (::Type{T})(x::$eT, r::RoundingMode) where {T<:Union{Float32,Float64}}
                Base._irrational_to_float(T, x, r)
            end
        end
        @static if isdefined(Base, :_rationalize_irrational)
            Base.@assume_effects :foldable function Base.rationalize(::Type{T}, x::$eT; tol::Real=0) where {T<:Integer}
                Base._rationalize_irrational(T, x, tol)
            end
        end
        @static if isdefined(Base, :_lessrational)
            Base.@assume_effects :foldable function Base.lessrational(rx::Rational, x::$eT)
                Base._lessrational(rx, x)
            end
        end
    end
end

using IrrationalConstants
using Documenter
using Test

const ALLCONSTANTS = filter!(
    x -> x isa IrrationalConstants.IrrationalConstant,
    map(Base.Fix1(getproperty, IrrationalConstants), names(IrrationalConstants)),
)

@testset "k*pi" begin
    @test isapprox(2*pi, twoπ)
    @test isapprox(4*pi, fourπ)
    @test isapprox(pi/2, halfπ)
    @test isapprox(pi/4, quartπ)
end

@testset "k/pi" begin
    @test isapprox(1/pi, invπ)
    @test isapprox(2/pi, twoinvπ)
    @test isapprox(4/pi, fourinvπ)
end

@testset "1/(k*pi)" begin  
    @test isapprox(1/(2pi), inv2π)
    @test isapprox(1/(4pi), inv4π)
end

@testset "sqrt" begin
    @test isapprox(sqrt(2), sqrt2)
    @test isapprox(sqrt(3), sqrt3)
    @test isapprox(sqrt(pi), sqrtπ)
    @test isapprox(sqrt(2pi), sqrt2π)
    @test isapprox(sqrt(4pi), sqrt4π)
    @test isapprox(sqrt(pi/2), sqrthalfπ)
    @test isapprox(sqrt(1/2), invsqrt2)
    @test isapprox(sqrt(1/(pi)), invsqrtπ)
    @test isapprox(sqrt(1/(2pi)), invsqrt2π)
end

@testset "log" begin
    @test isapprox(log(1/2), loghalf)
    @test isapprox(log(2), logtwo)
    @test isapprox(log(10), logten)
    @test isapprox(log(pi), logπ)
    @test isapprox(log(2pi), log2π)
    @test isapprox(log(4pi), log4π)
end

@testset "type system" begin
    @test twoπ === IrrationalConstants.Twoπ()
    @test twoπ isa IrrationalConstants.IrrationalConstant
    @test twoπ isa AbstractIrrational
end

@testset "hash" begin
    for i in ALLCONSTANTS, j in ALLCONSTANTS
        @test isequal(i==j, hash(i)==hash(j))
    end
end

@testset "doctests" begin
    doctest(IrrationalConstants; manual=false)
end

# copied from https://github.com/JuliaLang/julia/blob/cf5ae0369ceae078cf6a29d7aa34f48a5a53531e/test/numbers.jl
# and adapted to irrationals in this package

@testset "IrrationalConstants zero and one" begin
    for i in ALLCONSTANTS
        @test one(i) === true
        @test zero(i) === false
        @test one(typeof(i)) === true
        @test zero(typeof(i)) === false
    end
end

@testset "IrrationalConstants iszero, isfinite, isinteger, and isone" begin
    for i in ALLCONSTANTS
        @test !iszero(i)
        @test !isone(i)
        @test !isinteger(i)
        @test isfinite(i)
    end
end

@testset "IrrationalConstants promote_type" begin
    for T in (Float16, Float32, Float64)
        for i in ALLCONSTANTS
            @test T(2.0) * i ≈ T(2.0) * T(i)
            @test T(2.0) * i isa T
        end
    end
end

@testset "IrrationalConstants compared with IrrationalConstants" begin
    for i in ALLCONSTANTS, j in ALLCONSTANTS
        @test isequal(i==j, Float64(i)==Float64(j))
        @test isequal(i!=j, Float64(i)!=Float64(j))
        @test isequal(i<=j, Float64(i)<=Float64(j))
        @test isequal(i>=j, Float64(i)>=Float64(j))
        @test isequal(i<j, Float64(i)<Float64(j))
        @test isequal(i>j, Float64(i)>Float64(j))
    end
end

@testset "IrrationalConstants Inverses, JuliaLang/Julia Issue #30882" begin
    @test @inferred(inv(twoπ)) ≈ 0.15915494309189535
end

@testset "IrrationalConstants compared with Rationals and Floats" begin
    for i in ALLCONSTANTS
        @test Float64(i, RoundDown) < i
        @test Float64(i, RoundUp) > i
        @test !(Float64(i, RoundDown) > i)
        @test !(Float64(i, RoundUp) < i)
        @test Float64(i, RoundDown) <= i
        @test Float64(i, RoundUp) >= i
        @test Float64(i, RoundDown) != i
        @test Float64(i, RoundUp) != i

        @test Float32(i, RoundDown) < i
        @test Float32(i, RoundUp) > i
        @test !(Float32(i, RoundDown) > i)
        @test !(Float32(i, RoundUp) < i)

        @test prevfloat(big(i)) < i
        @test nextfloat(big(i)) > i
        @test !(prevfloat(big(i)) > i)
        @test !(nextfloat(big(i)) < i)
    end

    @test 5293386250278608690//842468587426513207 < twoπ
    @test !(5293386250278608690//842468587426513207 > twoπ)
    @test 5293386250278608690//842468587426513207 != twoπ
end
IrrationalConstants.@irrational i46051 4863.185427757 1548big(pi)
@testset "IrrationalConstant printing" begin
    @test sprint(show, "text/plain", twoπ) == "twoπ = 6.2831853071795..."
    @test sprint(show, "text/plain", twoπ, context=:compact => true) == "twoπ"
    @test sprint(show, twoπ) == "twoπ"
    # JuliaLang/Julia issue #46051
    @test sprint(show, "text/plain", i46051) == "i46051 = 4863.185427757..."
end

@testset "IrrationalConstant/Bool multiplication" begin
    @test false*twoπ === 0.0
    @test twoπ*false === 0.0
    @test true*twoπ === Float64(twoπ)
    @test twoπ*true === Float64(twoπ)
end

# JuliaLang/Julia issue #26324
@testset "irrational promotion" begin
    @test twoπ*ComplexF32(2) isa ComplexF32
    @test twoπ/ComplexF32(2) isa ComplexF32
    @test log(twoπ, ComplexF32(2)) isa ComplexF32
end

# issue #23
@testset "rounding irrationals" begin
    # without rounding mode
    @test @inferred(round(twoπ)) == 6.0
    @test @inferred(round(sqrt2)) == 1.0
    @test @inferred(round(sqrt3)) == 2.0
    @test @inferred(round(loghalf)) == -1.0

    # with rounding modes
    for mode in (RoundDown, RoundToZero, RoundNearest, RoundNearestTiesAway, RoundNearestTiesUp)
        @test @inferred(round(twoπ, mode)) == 6.0
        @test @inferred(round(sqrt2, mode)) == 1.0
    end
    @test @inferred(round(sqrt3, RoundUp)) == 2.0
    for mode in (RoundUp, RoundToZero)
        @test @inferred(round(loghalf, mode)) == 0.0
    end
end

@testset "trigonometric functions" begin
    # 2π, 4π
    for (n, x) in ((2, twoπ), (4, fourπ))
        @test sin(x) === sinpi(n) === sin(0.0)
        @test cos(x) === cospi(n) === cos(0.0)
    end

    # halfπ, quartπ
    for (r, x) in ((big"0.5", halfπ), (big"0.25", quartπ))
        @test sin(x) === Float64(sinpi(r))
        @test cos(x) === Float64(cospi(r))
    end

    # Check consistency of definitions
    for x in (twoπ, fourπ, halfπ, quartπ)
        @test sincos(x) === (sin(x), cos(x))
        @test tan(x) === sin(x) / cos(x)
    end

    # Check `csc`, `sec`, and `cot`
    for x in (twoπ, fourπ, halfπ)
        # These are defined automatically via sin, cos, and tan
        @test csc(x) === 1 / sin(x)
        @test sec(x) === 1 / cos(x)
        @test cot(x) === csc(x) / sec(x)
    end
    @test csc(quartπ) === Float64(csc(big(quartπ)))
    @test sec(quartπ) === Float64(sec(big(quartπ)))
    @test cot(quartπ) === Float64(cot(big(quartπ)))
end

# Ref https://github.com/JuliaLang/julia/pull/46054
IrrationalConstants.@irrational irrational_1548_pi 4863.185427757 1548big(pi)
IrrationalConstants.@irrational irrational_inv_1548_pi 1/big(irrational_1548_pi)
@testset "IrrationalConstants.@irrational" begin
    @test irrational_1548_pi ≈ 1548big(pi)
    @test Float64(irrational_1548_pi) == 1548π
    @test irrational_1548_pi ≈ 1548pi
    @test irrational_1548_pi != 1548pi
    @test irrational_inv_1548_pi ≈ inv(1548big(pi))
    @test Float64(irrational_inv_1548_pi) == 1/(1548π)
    @test irrational_inv_1548_pi ≈ inv(1548pi)
    @test irrational_inv_1548_pi != inv(1548pi)
end

# Ref https://github.com/JuliaLang/julia/pull/50894
@testset "irrational special values" begin
    for v ∈ ALLCONSTANTS
        @test v === typemin(v) === typemax(v)
    end
end

# Ref https://github.com/JuliaLang/julia/pull/55911
@testset "logtwo to `BigFloat` with `setrounding`" begin
    function irrational_to_big_float(c::AbstractIrrational)
        BigFloat(c)
    end

    function irrational_to_big_float_with_rounding_mode(c::AbstractIrrational, rm::RoundingMode)
        f = () -> irrational_to_big_float(c)
        setrounding(f, BigFloat, rm)
    end

    function irrational_to_big_float_with_rounding_mode_and_precision(c::AbstractIrrational, rm::RoundingMode, prec::Int)
        f = () -> irrational_to_big_float_with_rounding_mode(c, rm)
        setprecision(f, BigFloat, prec)
    end

    # logtwo is the only constant defined based on an MPFR constant (similar to π, γ, catalan)
    c = logtwo
    for p ∈ 1:40
        @test (
            irrational_to_big_float_with_rounding_mode_and_precision(c, RoundDown, p) < c <
            irrational_to_big_float_with_rounding_mode_and_precision(c, RoundUp, p)
        )
    end
end

# issues #37 and #40
@testset "slow comparisons" begin
    @test iszero(@allocated(3.0 <= invsqrt2))
end

# issues #43
@testset "macro error" begin
    msg = "The name of the irrational constant (Myπ) and its type (Myπ) cannot be the same. Please choose a different name for the constant or specify a different type name as the last argument to the macro."
    @test_throws ArgumentError(msg) @macroexpand(IrrationalConstants.@irrational Myπ big(π))
    @test_throws ArgumentError(msg) @macroexpand(IrrationalConstants.@irrational Myπ 1.0 big(π))
    @test_throws ArgumentError(msg) @macroexpand(IrrationalConstants.@irrational Myπ big(π) Myπ)
    @test_throws ArgumentError(msg) @macroexpand(IrrationalConstants.@irrational Myπ 1.0 big(π) Myπ)
end

# test that defining a type that already exists throws an error
module TestTypeCollision
    using IrrationalConstants
    using Test
    struct MyExistingType end

    @testset "type collision" begin
        msg1 = "Type `MyExistingType` of irrational constant `myExistingType` is already defined in module `Main.TestTypeCollision`."
        @test_throws ArgumentError(msg1) @macroexpand(IrrationalConstants.@irrational myExistingType big(π))
        msg2 = "Type `MyExistingType` of irrational constant `myconst` is already defined in module `Main.TestTypeCollision`."
        @test_throws ArgumentError(msg2) @macroexpand(IrrationalConstants.@irrational myconst big(π) MyExistingType)
        @test_throws ArgumentError(msg2) @macroexpand(IrrationalConstants.@irrational myconst 1.0 big(π) MyExistingType)
    end
end

# Functions return `Float64`, consistent with Base
# https://github.com/JuliaLang/julia/pull/42595
# Values at poles are defined to be consistent with `cot(0)` and `cot(π)`
# https://github.com/JuliaLang/julia/issues/7123
# https://github.com/JuliaLang/julia/blob/e3d366f1966595ba737220df49e220610823b331/base/mathconstants.jl#L130

# `sin`
Base.sin(::Twoπ) = 0.0
Base.sin(::Fourπ) = 0.0
Base.sin(::Halfπ) = 1.0
Base.sin(::Quartπ) = Float64(invsqrt2)

# `cos`
Base.cos(::Twoπ) = 1.0
Base.cos(::Fourπ) = 1.0
Base.cos(::Halfπ) = 0.0
Base.cos(::Quartπ) = Float64(invsqrt2)

# `sincos`
Base.sincos(::Twoπ) = (0.0, 1.0)
Base.sincos(::Fourπ) = (0.0, 1.0)
Base.sincos(::Halfπ) = (1.0, 0.0)
Base.sincos(::Quartπ) = (Float64(invsqrt2), Float64(invsqrt2))

# `tan`
Base.tan(::Twoπ) = 0.0
Base.tan(::Fourπ) = 0.0
Base.tan(::Halfπ) = 1/0
Base.tan(::Quartπ) = 1.0

# `csc`, `sec`, and `cot` are defined automatically, so we do not define them
# there is one exception where we can improve accuracy:
Base.csc(::Quartπ) = Float64(sqrt2)
Base.sec(::Quartπ) = Float64(sqrt2)

# mathematical constants related to statistics

@irrational twoπ 2 * big(π)
@irrational fourπ 4 * big(π)
@irrational halfπ big(π) / 2
@irrational quartπ big(π) / 4

@irrational invπ inv(big(π))
@irrational twoinvπ 2 / big(π)
@irrational fourinvπ 4 / big(π)
@irrational inv2π inv(2 * big(π))
@irrational inv4π inv(4 * big(π))

@irrational sqrt2 sqrt(big(2))
@irrational sqrt3 sqrt(big(3))
@irrational sqrtπ sqrt(big(π))
@irrational sqrt2π sqrt(2 * big(π))
@irrational sqrt4π sqrt(4 * big(π))
@irrational sqrthalfπ sqrt(big(π) / 2)

@irrational invsqrt2 inv(sqrt(big(2)))
@irrational invsqrtπ inv(sqrt(big(π)))
@irrational invsqrt2π inv(sqrt(2 * big(π)))

@irrational loghalf log(inv(big(2)))
@irrational logtwo log2
@irrational logten log(big(10))
@irrational logπ log(big(π))
@irrational log2π log(2 * big(π))
@irrational log4π log(4 * big(π))

module IrrationalConstants

export
    twoπ,       # 2π
    fourπ,      # 4π
    halfπ,      # π / 2
    quartπ,     # π / 4
    invπ,       # 1 / π
    twoinvπ,    # 2 / π
    fourinvπ,   # 4 / π
    inv2π,      # 1 / (2π)
    inv4π,      # 1 / (4π)
    sqrt2,      # √2
    sqrt3,      # √3
    sqrtπ,      # √π
    sqrt2π,     # √2π
    sqrt4π,     # √4π
    sqrthalfπ,  # √(π / 2)
    invsqrt2,   # 1 / √2
    invsqrtπ,   # 1 / √π
    invsqrt2π,  # 1 / √2π
    loghalf,    # log(1 / 2)
    logtwo,     # log(2)
    logten,     # log(10)
    logπ,       # log(π)
    log2π,      # log(2π)
    log4π       # log(4π)

include("macro.jl")
include("stats.jl")
include("trigonometric.jl")

end # module
